#include <GL/gl.h>
//#include <dff.h>
//#include <txd.h>

#ifndef DFFVIEWER_H
#define DFFVIEWER_H

#define GAMEPC  0x1
#define GAMEPS2 0x2
#define GAME3	0x4
#define GAMEVC	0x8

#include <rwcore.h>
#include <rpworld.h>

class Model {
private:
	RwTexDictionary *TexDict;
	GLuint *texid;

	RpClump *Clump;
	GLuint *DLarray;
public:
	void LoadTxd(void);
	void UnloadTxd(void);
	void SetRwTexDictionary(RwTexDictionary *);
	RwTexDictionary *GetRwTexDictionary(void);
	int GetTexIndex(RwChar *);
	RwBool BindTex(RwTexture *tex);

	void CreateDisplayLists(void);
	void DestroyDisplayLists(void);
	void SetClump(RpClump *);
	RpClump *GetClump(void);
	void TransformFrame(RwFrame *, int);
	void DrawGeometry(RpGeometry&, int);
	void DrawAtomicDL(int index);
	void DrawAtomic(int index);
	Model(void);
	~Model(void);
};

extern char progname[30];
extern Model mdl;
extern GLfloat camx, camy, camz;
extern GLfloat camyaw, campitch, camroll;
extern RwBool UseTextures;
extern RwBool UseDisplayLists;

void StartOgl(int, char**);
void RenderScene(void);
void Init(void);
void DeInit(void);

#endif
