#ifdef WIN32
  #include <windows.h>
#endif

#include <GL/glut.h>
#include <cmath>

#include "dffviewer.h"
#include "glut.h"

#ifndef M_PI
#define M_PI 3.1415
#endif

void Resize(int w, int h)
{
	h = getHeight();
	w = getWidth();

	glViewport(0, 0,w, h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(45.0f,(GLfloat)w/(GLfloat)h,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void Keypress(byte key, int x, int y)
{
	switch(key) {
	case 27:
		exit(0);
		break;
	default:
		break;
	}
}

void Keypress_spec(int key, int x, int y)
{
	float phi = M_PI/32;
	switch(key) {
	case GLUT_KEY_UP:
		camyaw += 2.0f;
		break;
	case GLUT_KEY_DOWN:
		camyaw -= 2.0f;
		break;
	case GLUT_KEY_LEFT:
		camroll -= 2.0f;
		break;
	case GLUT_KEY_RIGHT:
		camroll += 2.0f;
		break;
	case GLUT_KEY_PAGE_UP:
		camz += 0.7f;
		break;
	case GLUT_KEY_PAGE_DOWN:
		camz -= 0.7f;
		break;
	default:
		break;
	}
}

void SwapBuffers(void)
{
	glutSwapBuffers();
}

int getWidth(void)
{
	return 600;
}

int getHeight(void)
{
	return 400;
}

void StartOgl(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA);
	glutInitWindowSize(600, 400);
	glutCreateWindow(progname);
	Init();
	glutDisplayFunc(RenderScene);
	glutReshapeFunc(Resize);
	glutKeyboardFunc(Keypress);
	glutSpecialFunc(Keypress_spec);
	glutIdleFunc(RenderScene);
	glutMainLoop();
}
