#ifdef WIN32
  #include <windows.h>
#endif

#include <iostream>
#include <fstream>
#include <cstring>

#include <rwcore.h>
#include <rpworld.h>

#include "dffviewer.h"

using namespace std;

//CGlDff dff;
//CGlTxd txd;
Model mdl;
RwBool UseTextures;
RwBool UseDisplayLists;

int main(int argc, char *argv[])
{
	RwStream *sdff;
	RwStream *stxd;
	RpClump *Clump;
	RwTexDictionary *TexDict;

	UseDisplayLists = FALSE;

	strncpy(progname, "DFF Viewer", 30);

	if (argc < 2) {
		cerr << "Usage: " << argv[0] << " dff [txd]\n";
		exit(1);
	}
	UseTextures = argc > 2 ? 1 : 0;

	if ((sdff = RwStreamOpen(rwSTREAMFILENAME, rwSTREAMREAD, argv[1]))
	    == NULL) {
		cerr << "Couldn't open file: " << argv[1] << endl;
		exit(1);
	}
	Clump = RpClumpStreamRead(sdff);
	mdl.SetClump(Clump);
	cout << "Done loading dff\n";


	if (UseTextures) {
		if ((stxd = RwStreamOpen(rwSTREAMFILENAME, rwSTREAMREAD,
		    argv[2])) == NULL) {
			cerr << "Couldn't open file: " << argv[2] << endl;
			exit(1);
		}
		TexDict = RwTexDictionaryStreamRead(stxd);
		mdl.SetRwTexDictionary(TexDict);
		cout << "Done loading txd\n";
	}


	StartOgl(argc, argv);
}

