#include <iostream>
#include "dffviewer.h"
using namespace std;

RwBool CGlTxd::BindTex(RwTexture *tex)
{
	RwInt32 index;

	if ((index = GetTexIndex(tex->Name)) != -1)
		glBindTexture(GL_TEXTURE_2D, texid[index]);
	else
		glBindTexture(GL_TEXTURE_2D, 0);
	return TexDict->raster[index].HasAlpha;
}

void CGlTxd::LoadTxd()
{
	RwUInt32 i;

	texid = new GLuint[TexDict->numRasters];
	glGenTextures(TexDict->numRasters, texid);
	for (i = 0; i < TexDict->numRasters; i++) {
		glBindTexture(GL_TEXTURE_2D, texid[i]);

		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

		if (TexDict->raster[i].depth == 32) {
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,
			             TexDict->raster[i].width,
			             TexDict->raster[i].height,
			             0, GL_RGBA, GL_UNSIGNED_BYTE,
			             TexDict->raster[i].Data_a);
		} else {
			cerr << "Can't handle non 32bit textures\n";
			exit(1);
		}
	}
}

void CGlTxd::UnloadTxd()
{
	RwUInt32 i;

	for (i = 0; i < TexDict->numRasters; i++)
		glDeleteTextures(1, &texid[i]);
}

RwInt32 CGlTxd::GetTexIndex(char *Name)
{
	RwUInt32 i;

	for (i = 0; i < TexDict->numRasters; i++)
		if (strcasecmp(TexDict->raster[i].Name, Name) == 0)
			return i;
	return -1;
}

void CGlTxd::SetRwTexDictionary(RwTexDictionary *td)
{
	TexDict = td;
}

RwTexDictionary *CGlTxd::GetRwTexDictionary()
{
	return TexDict;
}
