#ifndef RW_RW_H
#define RW_RW_H

#include <fstream>
using namespace std;

typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
typedef char int8;
typedef unsigned char uint8;
typedef unsigned char byte;

uint32 ReadDword(istream&);
uint32 PeekDword(istream&);
uint16 ReadWord(istream&);
uint8 ReadByte(istream&);
float ReadFloat(istream&);
void WriteDword(ostream&, uint32);
void WriteWord(ostream&, uint16);
void WriteByte(ostream&, uint8);
void WriteFloat(ostream&, float);

class CHeader {
private:
	int Type;
	int Size;
	int Version;
public:
	void   SetType(uint32);
	void   SetSize(uint32);
	void   SetVersion(uint32);
	void   SetEverything(uint32 t, uint32 s, uint32 v);
	uint32 GetType(void);
	uint32 GetSize(void);
	uint32 GetVersion(void);
	char   *GetSectionName(uint32);
	void   Write(ostream&);
	void   Read(istream&);

	CHeader();
	CHeader(uint32 t, uint32 s, uint32 v);
	~CHeader();
};

#endif
