#include "rw.h"

#ifndef RW_TXD_H
#define RW_TXD_H

enum {
	TPC   = 8,
	TSA   = 9,
	TPS2  = 0x00325350,
	TXBOX = 5
};

typedef struct SPicture SPicture;
struct SPicture {
	char Name[32];
	char Alpha[32];
	int FilterFlags;
	uint32 Width, Height;
	uint32 Bpp;
	byte *Data; 
	byte *Data_a; 
	uint32 HasAlpha;

	/* PC only */
	int RasterFormat;
	uint32 MipmapCount;
	int Compression;
	uint32 *Size;
};

class CTxd {
public:
	SPicture *Tex;
	uint32 numTextures;

	void ReadFromFile(istream&);
	void ReadFromFile(istream&, uint32 start, uint32 end);
	void ReadPcTxd(istream&, SPicture&, uint32 end);
	void ReadPs2Txd(istream&, SPicture&);
	CTxd(void);
	~CTxd(void);
};

#endif
