#include <iostream>
#include "mapviewer.h"
using namespace std;

void CSky::ReadWeatherData()
{
	int i;
	int numEntries;
	char buffer[512];
	char *pos;
	FILE *timecyc;
	Weather weather;

	if ((timecyc = fopen("DATA/TIMECYC.DAT", "r")) == NULL) {
		cerr << "Couldn't find timecyc.dat\n";
		exit(1);
	}

	if ((Game & GAMEIII) != 0) {
		numWeather = 4;
		numEntries = 24;
	} else if ((Game & GAMEVICECITY) != 0) {
		numWeather = 6;
		numEntries = 24;
	} else {
		numWeather = 23;
		numEntries = 8;
	}

	for (i = 0; i < numWeather*numEntries; i++) {
		ReadConfigLine(timecyc, buffer);
		pos = buffer;

		if ((Game & GAMEIII) != 0) {
			sscanf(buffer, "%hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %f %f %f %d %d %d %f %f %f"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu %hhu %hhu %hhu %hhu",
			       &weather.Amb[0], &weather.Amb[1],&weather.Amb[2],
			       &weather.Dir[0], &weather.Dir[1],&weather.Dir[2],
			       &weather.Sky_top[0], &weather.Sky_top[1],
			       &weather.Sky_top[2],
			       &weather.Sky_bot[0], &weather.Sky_bot[1],
			       &weather.Sky_bot[2],
			       &weather.SunCore[0], &weather.SunCore[1],
			       &weather.SunCore[2],
			       &weather.SunCorona[0], &weather.SunCorona[1],
			       &weather.SunCorona[2],
			       &weather.SunSz, &weather.SprSz, &weather.SprBght,
			       &weather.Shdw,
			       &weather.LightShd, &weather.TreeShd,
			       &weather.FarClp, &weather.FogSt,
			       &weather.LightOnGround,
			       &weather.LowCloudsRGB[0],
			       &weather.LowCloudsRGB[1],
			       &weather.LowCloudsRGB[2],
			       &weather.TopCloudRGB[0], &weather.TopCloudRGB[1],
			       &weather.TopCloudRGB[2],
			       &weather.BottomCloudRGB[0],
			       &weather.BottomCloudRGB[1],
			       &weather.BottomCloudRGB[2],
			       &weather.Tint[0], &weather.Tint[1],
			       &weather.Tint[2], &weather.Tint[3]);
			WeatherList.push_back(weather);
		} else if ((Game & GAMEVICECITY) != 0) {
			sscanf(buffer, "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %f %f %f %d %d %d %f %f %f"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu %hhu",
			       &weather.Amb[0], &weather.Amb[1],&weather.Amb[2],
			       &weather.Amb_Obj[0], &weather.Amb_Obj[1],
			       &weather.Amb_Obj[2],
			       &weather.Amb_Bl[0], &weather.Amb_Bl[1],
			       &weather.Amb_Bl[2],
			       &weather.Amb_Obj_bl[0], &weather.Amb_Obj_bl[1],
			       &weather.Amb_Obj_bl[2],
			       &weather.Dir[0], &weather.Dir[1],&weather.Dir[2],
			       &weather.Sky_top[0], &weather.Sky_top[1],
			       &weather.Sky_top[2],
			       &weather.Sky_bot[0], &weather.Sky_bot[1],
			       &weather.Sky_bot[2],
			       &weather.SunCore[0], &weather.SunCore[1],
			       &weather.SunCore[2],
			       &weather.SunCorona[0], &weather.SunCorona[1],
			       &weather.SunCorona[2],
			       &weather.SunSz, &weather.SprSz, &weather.SprBght,
			       &weather.Shdw,
			       &weather.LightShd, &weather.PoleShd,
			       &weather.FarClp, &weather.FogSt,
			       &weather.LightOnGround,
			       &weather.LowCloudsRGB[0],
			       &weather.LowCloudsRGB[1],
			       &weather.LowCloudsRGB[2],
			       &weather.TopCloudRGB[0], &weather.TopCloudRGB[1],
			       &weather.TopCloudRGB[2],
			       &weather.BottomCloudRGB[0],
			       &weather.BottomCloudRGB[1],
			       &weather.BottomCloudRGB[2],
			       &weather.BlurRGB[0], &weather.BlurRGB[1],
			       &weather.BlurRGB[2],
			       &weather.WaterRGBA[0], &weather.WaterRGBA[1],
			       &weather.WaterRGBA[2], &weather.WaterRGBA[3]);
			WeatherList.push_back(weather);
		} else {
			sscanf(buffer, "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu  %f %f %f %d %d %d %f %f %f"
			       "%hhu %hhu %hhu  %hhu %hhu %hhu"
			       "%hhu %hhu %hhu %hhu" "%hhu %hhu %hhu %hhu"
			       "%hhu %hhu %hhu %hhu %f",
			       &weather.Amb[0], &weather.Amb[1],&weather.Amb[2],
			       &weather.Amb_Obj[0], &weather.Amb_Obj[1],
			       &weather.Amb_Obj[2],
			       &weather.Dir[0], &weather.Dir[1],&weather.Dir[2],
			       &weather.Sky_top[0], &weather.Sky_top[1],
			       &weather.Sky_top[2],
			       &weather.Sky_bot[0], &weather.Sky_bot[1],
			       &weather.Sky_bot[2],
			       &weather.SunCore[0], &weather.SunCore[1],
			       &weather.SunCore[2],
			       &weather.SunCorona[0], &weather.SunCorona[1],
			       &weather.SunCorona[2],
			       &weather.SunSz, &weather.SprSz, &weather.SprBght,
			       &weather.Shdw,
			       &weather.LightShd, &weather.PoleShd,
			       &weather.FarClp, &weather.FogSt,
			       &weather.LightOnGround,
			       &weather.LowCloudsRGB[0],
			       &weather.LowCloudsRGB[1],
			       &weather.LowCloudsRGB[2],
			       &weather.TopCloudRGB[0], &weather.TopCloudRGB[1],
			       &weather.TopCloudRGB[2],
			       &weather.WaterRGBA[0], &weather.WaterRGBA[1],
			       &weather.WaterRGBA[0], &weather.WaterRGBA[1],
			       &weather.RGBA1[3], &weather.RGBA1[0],
			       &weather.RGBA1[1], &weather.RGBA1[2],
			       &weather.RGBA2[3], &weather.RGBA2[0],
			       &weather.RGBA2[1], &weather.RGBA2[2],
			       &weather.CloudAlpha);
			if (i == 0) { /* Midnight */
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
			} else if (i == 3) { /* 7AM */
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
			} else if (i == 4) { /* Midday */
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
			} else if (i == 6) { /* 8PM */
				WeatherList.push_back(weather);
				WeatherList.push_back(weather);
			} else if (i == 7) { /* 10PM */
				WeatherList.push_back(weather);
			} else {
				WeatherList.push_back(weather);
			}
		}

/*
		pos = GetRGB(pos, weather.Amb);
		if ((Game & GAMEVICECITY) != NULL) {
			pos = GetRGB(pos, weather.Amb_Obj);
			pos = GetRGB(pos, weather.Amb_Bl);
			pos = GetRGB(pos, weather.Amb_Obj_bl);
		}
		pos = GetRGB(pos, weather.Dir);
		pos = GetRGB(pos, weather.Sky_top);
		pos = GetRGB(pos, weather.Sky_bot);
		pos = GetRGB(pos, weather.SunCore);
		pos = GetRGB(pos, weather.SunCorona);
		pos = GetFloat(pos, &weather.SunSz);
		pos = GetFloat(pos, &weather.SprSz);
		pos = GetFloat(pos, &weather.SprBght);
		pos = GetInt(pos, &weather.Shdw);
		pos = GetInt(pos, &weather.LightShd);
		if ((Game & GAMEVICECITY) != NULL) {
			pos = GetInt(pos, &weather.PoleShd);
		} else {
			pos = GetInt(pos, &weather.TreeShd);
		}
		pos = GetFloat(pos, &weather.FarClp);
		pos = GetFloat(pos, &weather.FogSt);
		pos = GetFloat(pos, &weather.LightOnGround);
		pos = GetRGB(pos, weather.LowCloudsRGB);
		pos = GetRGB(pos, weather.TopCloudRGB);
		pos = GetRGB(pos, weather.BottomCloudRGB);
		if ((Game & GAMEVICECITY) != NULL) {
			pos = GetRGB(pos, weather.BlurRGB);
			pos = GetRGBA(pos, weather.WaterRGBA);
		}
*/
	}

	fclose(timecyc);
}

void CSky::Dump()
{
	int i;
	for (i = 0; i < WeatherList.size(); i++) {
//		printf("%d %d %d\n", WeatherList[i].BottomCloudRGB[0],
//		WeatherList[i].BottomCloudRGB[1],
//		WeatherList[i].BottomCloudRGB[2]);
	}
}

void CSky::GetWaterColor(byte *color)
{
	byte *water1, *water2;

	water1 = WeatherList[Clock.GetHour()+WeatherSelector*24].WaterRGBA;
	Clock.AdvanceOneHour();
	water2 = WeatherList[Clock.GetHour()+WeatherSelector*24].WaterRGBA;
	Clock.TurnBackOneHour();
	MixColors(color, water1, water2, 60-Clock.GetMinute(), 60);
}

void CSky::GetTintColor(byte *color)
{
	byte *tint1, *tint2;

	tint1 = WeatherList[Clock.GetHour()+WeatherSelector*24].Tint;
	Clock.AdvanceOneHour();
	tint2 = WeatherList[Clock.GetHour()+WeatherSelector*24].Tint;
	Clock.TurnBackOneHour();
	MixColors(color, tint1, tint2, 60-Clock.GetMinute(), 60);
	color[0] = (byte) (color[0] * 0.6);
	color[1] = (byte) (color[1] * 0.6);
	color[2] = (byte) (color[2] * 0.6);
	color[3] = (byte) (color[3] * 0.6);
}


void CSky::GetSky_top(byte *color)
{
	byte *top1, *top2;

	top1 = WeatherList[Clock.GetHour()+WeatherSelector*24].Sky_top;
	Clock.AdvanceOneHour();
	top2 = WeatherList[Clock.GetHour()+WeatherSelector*24].Sky_top;
	Clock.TurnBackOneHour();
	MixColors(color, top1, top2, 60-Clock.GetMinute(), 60);
}

void CSky::GetSky_bot(byte *color)
{
	byte *bot1, *bot2;

	bot1 = WeatherList[Clock.GetHour()+WeatherSelector*24].Sky_bot;
	Clock.AdvanceOneHour();
	bot2 = WeatherList[Clock.GetHour()+WeatherSelector*24].Sky_bot;
	Clock.TurnBackOneHour();
	MixColors(color, bot1, bot2, 60-Clock.GetMinute(), 60);
}

int CSky::GetWeatherSelector()
{
	return WeatherSelector;
}

void CSky::Draw()
{
	GLfloat pos[3];
	GLfloat cz, cx;
	GLfloat r;
	GLfloat phi;
	color skytop;
	color skybot;
	GLfloat top;
	GLfloat FogCol[4];
	GLfloat FogSt, FarClp;

	GetSky_top(skytop);
	GetSky_bot(skybot);

	glDisable(GL_FOG);
	glClearColor((GLclampf) skytop[0]/255,
	             (GLclampf) skytop[1]/255,(GLclampf) skytop[2]/255, 1.0f);
	Camera.GetPosition(&pos[0], &pos[1], &pos[2]);
	phi = Camera.GetYaw();

	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, 0);

	glPushMatrix();
	glTranslatef(pos[0], pos[1], pos[2]+0.5);
	glRotatef(phi, 0.0f, 0.0f, 1.0f);
	glScalef(1, 1, 1);

	cz = -0.0f;
	cx = 1.0f;
	r = 1.0f;
	top = r-r*0.9;

	// Common Axis Z - FRONT side
	glBegin(GL_QUADS);
	glColor3ubv(skybot);
	glVertex3f(-r ,1.0f,-r);
	glColor3ubv(skytop);
	glVertex3f(-r,1.0f, top);
	glVertex3f( r,1.0f, top);
	glColor3ubv(skybot);
	glVertex3f( r ,1.0f,-r);
	glEnd();


	// Common Axis Z - BACK side
	glBegin(GL_QUADS);
	glColor3ubv(skybot);
	glVertex3f(-r,-1.0f,-r);
	glColor3ubv(skytop);
	glVertex3f(-r,-1.0f, top);
	glVertex3f( r,-1.0f, top);
	glColor3ubv(skybot);
	glVertex3f( r,-1.0f,-r);
	glEnd();

	// Common Axis X - Left side
	glBegin(GL_QUADS);
	glColor3ubv(skytop);
	glVertex3f(-1.0f, -r, top);
	glVertex3f(-1.0f,  r, top);
	glColor3ubv(skybot);
	glVertex3f(-1.0f,  r,-r);
	glVertex3f(-1.0f, -r,-r);
	glEnd();


	// Common Axis X - Right side
	glBegin(GL_QUADS);
	glColor3ubv(skytop);
	glVertex3f(1.0f, -r, top);
	glVertex3f(1.0f,  r, top);
	glColor3ubv(skybot);
	glVertex3f(1.0f,  r,-r);
	glVertex3f(1.0f, -r,-r);
	glEnd();

	// Common Axis Y - Draw Up side
	glColor3ubv(skytop);
	glBegin(GL_QUADS);              
	glVertex3f( r, -r,top);
	glVertex3f( r,  r,top); 
	glVertex3f(-r,  r,top);
	glVertex3f(-r, -r,top);
	glEnd();

	// Common Axis Y - Down side
	glColor3ubv(skybot);
	glBegin(GL_QUADS);
	glVertex3f( r, -r,-1.0f);
	glVertex3f( r,  r,-1.0f);
	glVertex3f(-r,  r,-1.0f);
	glVertex3f(-r, -r,-1.0f);
	glEnd();

	glPopMatrix();

	glEnable(GL_DEPTH_TEST);

	if (UseFog) {
		FogSt = WeatherList[Clock.GetHour()+WeatherSelector*24].FogSt;
		FarClp = WeatherList[Clock.GetHour()+WeatherSelector*24].FarClp;
		glEnable(GL_FOG);
		FogCol[0] = (GLfloat)skytop[0]/255.0f;
		FogCol[1] = (GLfloat)skytop[1]/255.0f;
		FogCol[2] = (GLfloat)skytop[2]/255.0f;
		FogCol[3] = 0;
		glFogfv(GL_FOG_COLOR, FogCol);
		glFogi(GL_FOG_MODE, GL_EXP2);
		glFogf(GL_FOG_DENSITY, 0.0025f);
		glFogf(GL_FOG_START, FogSt);
		glFogf(GL_FOG_END, FarClp/4);
	}
}

void CSky::NextWeather()
{
	WeatherSelector++;
	printf("%d\n", numWeather);
	if (WeatherSelector >= numWeather)
		WeatherSelector = 0;
}

void CSky::PreviousWeather()
{
	WeatherSelector--;
	if (WeatherSelector < 0)
		WeatherSelector = numWeather-1;
}

CSky::CSky()
{
	numWeather = 0;
	WeatherSelector = 0;
}

CSky::~CSky()
{
}
