#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "rwcore.h"

void WriteByte(RwStream *s, RwUInt8 byte)
{
	RwStreamWrite(s, &byte, 1);
}

void WriteWord(RwStream *s, RwUInt16 word)
{
	RwStreamWrite(s, &word, 2);
}

void WriteTga(RwTexture *tex)
{
	int i;
	RwStream *tga;
	char filename[36];

	strcpy(filename, tex->Name);
	strcat(filename, ".tga");
	tga = RwStreamOpen(rwSTREAMFILENAME, rwSTREAMWRITE, filename);

	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 2);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteByte(tga, 0);
	WriteWord(tga, tex->width);
	WriteWord(tga, tex->height);
	WriteByte(tga, 0x20);
	WriteByte(tga, 0x28);

	for (i = 0; i < tex->width*tex->height; i++) {
		WriteByte(tga, tex->Data_a[i*4+2]);
		WriteByte(tga, tex->Data_a[i*4+1]);
		WriteByte(tga, tex->Data_a[i*4]);
		WriteByte(tga, tex->Data_a[i*4+3]);
	}

	RwStreamClose(tga, NULL);
}

int main(int argc, char *argv[])
{
	int i;
	RwStream *txds;
	RwTexDictionary *Dict;

	txds = RwStreamOpen(rwSTREAMFILENAME, rwSTREAMREAD, argv[1]);
	if (txds == NULL) {
		printf("Couldn't open file: %s\n", argv[1]);
		exit(1);
	}
	Dict = RwTexDictionaryStreamRead2(txds, 0);
	RwStreamClose(txds, NULL);

	for (i = 0; i < Dict->numTextures; i++) {
		WriteTga(&Dict->texture[i]);
	}
	return 0;
}
